#include<vector>
#include<iostream>
#include<algorithm>
using namespace std;
int main()
{
    int n,q,i,j,o;
    int sp=0;
    cin>>n>>q;
    if(n>300000 && q>300000){
        q=300000;
        n=300000;
    }
    vector<long long int>di(n);
    for(i=0;i<n;i++)
        cin>>di[i];
    vector<int>pi(n);
    for(i=0;i<n;i++)
        cin>>pi[i];
    for(i=0;i<n;i++)
        sp+=pi[i];
    vector<long long int>kj(q);
    for(j=0;j<q;j++){
        cin>>kj[j];
        if (kj[j]<=di[i]){
            o=0;
        }
        else{
            if((kj[j]+1-di[0])<sp){
                o=kj[j]+1-di[0];
            }
            else{
                o=sp;
            }
        }
        cout<<o<<" ";
    }
    return 0;
}